(*
 * Functions to check for well-kinded type expressions
 * (and to convert tyes into our internal format).
 *)

val wellKinded : 'a Types.c -> 'a Enco.ec -> Syntax.ty -> 
  (Types.t * Enco.ty * 'a Enco.ec)

val wellKindedConstr : 'a Types.c -> 'a Enco.ec -> Syntax.constr -> 
  (Types.constr * Enco.constr * 'a Enco.ec)

val hasKindType : 'a Types.c -> 'a Enco.ec -> Syntax.ty -> 
  (Types.t * Enco.ty * 'a Enco.ec)

val mkRecord : Error.info -> Types.field list -> Types.t

val scanT : 'a Types.c -> 'a Enco.ec -> Syntax.ty -> Enco.ty
val scanOptT : 'a Types.c -> 'a Enco.ec -> Syntax.ty option -> Enco.ty option
